package EnvMusicPackage
{
	function Environment::copyFrom(%this,%other)
	{
		if(!isObject(%other))
			return;
		if(isObject(%other.music))	//just a datablock, don't need to clone.
			%this.music = %other.music;
		return Parent::copyFrom(%this, %other);
	}
	function GameConnection::setEnvironment(%this,%env)
	{
		if(%this.currentEnvironment == %env)
			return;
		Parent::setEnvironment(%this, %env);
		%this.setMusic(%env.music,0.9);
	}
	function serverCmdSetWrenchData(%client,%data)
	{
		if(%client.wrenchBrick.getName() $= "EnvironmentZone")
		{
			%music = getWord(getField(%data,1),1);
			%client.wrenchBrick.environment.music = %music;
			%cc = ClientGroup.getCount();
			for(%x=0;%x<%cc;%x++)
			{
				%cl = ClientGroup.getObject(%x);
				if(%cl.currentEnvironment == %client.wrenchBrick.environment)
					%cl.setMusic(%music,0.9);
			}
			messageClient(%client,'',"\c6Set the environment's music to " @ %music.uiName);
			return;
		}
		Parent::serverCmdSetWrenchData(%client,%data);
	}
	function exportEnvironmentZones(%filename)
	{	//Wizardry here.
		%ec = EnvironmentZoneGroup.getCount();
		for(%i = 0; %i < %ec; %i++)
		{
			%zone = EnvironmentZoneGroup.getObject(%i);
			%env = %zone.environment;
			%zone.oldpoint2 = %zone.point2;
			if(isObject(%env.music))
				%zone.point2 = %zone.point2 NL "Music" TAB %env.music.getName();
		}
		%ret = Parent::exportEnvironmentZones(%filename);
		for(%i = 0; %i < %ec; %i++)
		{
			%zone = EnvironmentZoneGroup.getObject(%i);
			%zone.point2 = %zone.oldpoint2;
		}
		return %ret;
	}
	function setEnvVariable(%varName, %value)
	{
		if(%varName $= "Music")
		{
			$EnvMusic = %value;
			return 1;
		}
		return Parent::setEnvVariable(%varname,%value);
	}
	function Environment::postEditCheck(%this)
	{
		Parent::postEditCheck(%this);
		if(isObject($EnvMusic))
		{
			%this.music = $EnvMusic.getID();
			$EnvMusic = "";
		}
	}
};
ActivatePackage(EnvMusicPackage);

function serverCmdSetEnvZoneMusic(%client,%n1,%n2,%n3,%n4,%n5)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', $EZ::AdminFailMsg);
		return;
	}
	%name = trim(%n1 SPC %n2 SPC %n3 SPC %n4 SPC %n5);
	if(!strLen(%name))
	{
		messageClient(%client, '', "\c0You have to specify a name for the zone to set music!");
		return;
	}
	%zone = findEnvZoneByName(%name);
	if(!isObject(%zone))
	{
		messageClient(%client, '', "\c0There is no zone with that name!");
		return;
	}
	%client.wrenchBrick = %zone;
	%music = %zone.environment.music;
	if(!isObject(%music))
		%music = 0;
	commandToClient(%client,'SetWrenchData',"N" SPC "_" @ %name TAB "SDB" SPC %music);
	commandToClient(%client,'WrenchLoadingDone');
	commandToClient(%client,'openWrenchSoundDlg',"Environment Zone",1);
}